﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private  MAXORD As Int
	Private DTR, A, B, RE, A2, B2, C2, A4, B4, C4 As Double
	Private GNM, HNM, DGNM, DHNM, FLNMJ As Double
	Private OTIME, OALT, OLAT As Double
	Private EPOCH, TIME As Double

	Private  C(13, 13) As Double
	Private  CD(13, 13) As Double
	Private  P(13, 13) As Double
	Private  DP(13, 13) As Double
	Private  SNORM(13, 13) As Double
	Private  K(13, 13) As Double
	Private SP(13) As Double
	Private CP(13) As Double
	Private FN(13) As Double
	Private FM(13) As Double
	Private PP(13) As Double
	
End Sub

Public Sub Initialize
	
End Sub

Private Sub DoInitialize
	Dim lines As List = File.ReadList(File.DirAssets, "wmmc.cof")
	Dim FirstLine() As String = Regex.Split(",", lines.Get(0))
	EPOCH = FirstLine(0)
	MAXORD = 12
	DTR = cPI / 180
	SP(0) = 0
	CP(0) = 1
	P(0, 0) = 1
	PP(0) = 1
	DP(0, 0) = 0
	A = 6378.137
	B = 6356.7523142
	RE = 6371.2
	A2 = A*A
	B2 = B*B
	C2 = A2-B2
	A4 = A2*A2
	B4 = B2*B2
	C4 = A4-B4
	C(0,0)= 0
	CD(0,0) = 0
	For i = 1 To lines.Size - 1
		Dim line As String = lines.Get(i)
		line = line.Replace(" ", "")
		Dim str() As String = Regex.Split(",", line)
		If str(0) >= 13 Then
			 Exit
		End If
		Dim N As Int = str(0)
		Dim M As Int = str(1)
		GNM = str(2)
		HNM = str(3)
		DGNM = str(4)
		DHNM = str(5)
		If (M <= N) Then
			C(N,M) = GNM
			CD(N,M) = DGNM
			If(M <> 0) Then
				C(M-1,N) = HNM
				CD(M-1,N) = DHNM
			End If
		End If
	Next
	SNORM(0,0) = 1
	For n = 1 To MAXORD
		SNORM(n,0)= SNORM(n-1,0) * (2*n-1)/n
		Dim J = 2 As Int
		For m = 0 To n
			K(n,m) =((n-1)*(n-1)-m*m)/((2*n-1)*(2*n-3))
			If (m > 0) Then
				FLNMJ = ((n-m+1)* J)/(n+m)
				SNORM(n,m) = SNORM(n,m-1) * Sqrt(FLNMJ)
				J=1
				C(m-1,n) = SNORM(n,m) * C(m-1,n)
				CD(m-1,n) = SNORM(n,m) * CD(m-1,n)
			End If
			C(n,m) = SNORM(n,m) * C(n,m)
			CD(n,m) = SNORM(n,m) * CD(n,m)
		Next
			
		FN(n)= (n+1)
		FM(n) = (n)
	Next
	K(1,1) = 0
	OTIME = -1000
	OALT = -1000
	OLAT = -1000
	TIME = DateTime.GetDayOfYear(DateTime.Now) / 365 + DateTime.GetYear(DateTime.Now)
End Sub

Public Sub MagneticData(LAT As Double,LON As Double, ALT As Double) As String()
	Dim DT, RLON, RLAT, SRLON, SRLAT, CRLON, CRLAT As Double
	Dim  SRLAT2,  CRLAT2 As Double
	Dim Q, Q1, Q2, CT, ST, R2, R, D, CA, SA, AOR, AR As Double
	Dim BR, BT, BP, BPP, PAR, TEMP1, TEMP2, PARP As Double
	Dim BX, BY, BZ, BH As Double
	Dim TC(13, 13) As Double
	Dim str(3) As String
		 
		
	DoInitialize
		
		 
	DT = TIME - EPOCH
		 
	RLON = LON * DTR
	RLAT = LAT * DTR
	SRLON = Sin(RLON)
	SRLAT = Sin(RLAT)
	CRLON = Cos(RLON)
	CRLAT = Cos(RLAT)
	SRLAT2 = SRLAT*SRLAT
	CRLAT2 = CRLAT*CRLAT
	SP(1) = SRLON
	CP(1) = CRLON
		
		
	Q = Sqrt(A2 - C2 * SRLAT2)
	Q1 = ALT * Q
	Q2 = ((Q1+A2)/(Q1+B2))*((Q1+A2)/(Q1+B2))
	CT = SRLAT/Sqrt(Q2*CRLAT2+SRLAT2)
	ST = Sqrt(1-CT*CT)
	R2 = ALT*ALT+2*Q1+(A4-C4*SRLAT2)/(Q*Q)
	R = Sqrt(R2)
	D = Sqrt(A2*CRLAT2+B2*SRLAT2)
	CA = (ALT+D)/R
	SA = C2*CRLAT*SRLAT/(R*D)
	For m = 2 To MAXORD
		SP(m)=SP(1)*CP(m-1)+CP(1)*SP(m-1)
		CP(m)=CP(1)*CP(m-1)-SP(1)*SP(m-1)
	Next
	AOR = RE/R
	AR = AOR*AOR
	BR = 0
	BT = 0
	BP = 0
	BPP = 0
	For n = 1 To MAXORD
		
		AR = AR*AOR
		For m = 0 To n
			 
			'COMPUTE UNNORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS
			'And DERIVATIVES VIA RECURSION RELATIONS
			If ((ALT <> OALT) Or (LAT <> OLAT)) Then
				If (n = m) Then
					P(n,m) = ST*P(n-1,m-1)
					DP(n,m)=ST*DP(n-1,m-1)+CT*P(n-1,m-1)
				else if (n == 1 And m == 0) Then
					P(n,m)=CT*P(n-1,m)
					DP(n,m)=CT*DP(n-1,m)-ST*P(n-1,m)
				else if (n > 1 And n <> m) Then
					If (m > n-2) Then P(n-2,m) = 0
					If (m > n-2) Then DP(n-2,m) = 0
					P(n,m)=CT*P(n-1,m)-K(n,m)*P(n-2,m)
					DP(n,m)=CT*DP(n-1,m)-ST*P(n-1,m)-K(n,m)*DP(n-2,m)
				End If
			End If
			'  TIME ADJUST THE GAUSS COEFFICIENTS
		
			If (TIME <> OTIME) Then
				TC(n,m) = C(n,m) + DT*CD(n,m)
				If (m <> 0) Then TC(m-1,n) = C(m-1,n) + DT * CD(m-1,n)
			End If
			' ACCUMULATE TERMS OF THE SPHERICAL HARMONIC EXPANSIONS
			PAR = AR*P(n,m)
			If (m == 0) Then
				TEMP1 = TC(n,m)*CP(m)
				TEMP2 = TC(n,m)*SP(m)
			Else
				TEMP1 = TC(n,m)*CP(m)+TC(m-1,n)*SP(m)
				TEMP2 = TC(n,m)*SP(m)-TC(m-1,n)*CP(m)
			End If
			BT = BT -(AR * TEMP1 * DP(n,m))
			BP = BP +( FM(m) * TEMP2 * PAR)
			BR = BR +( FN(n) * TEMP1 * PAR)
			'SPECIAL Case:  NORTH/SOUTH GEOGRAPHIC POLES
			If (ST = 0 And m = 1) Then
				If (n = 1) Then
					PP(n)=PP(n-1)
				Else
					PP(n)=CT*PP(n-1)-K(n,m)*PP(n-2)
					PARP = AR*PP(n)
					BPP = BPP + FM(m) * TEMP2 * PARP
				End If
			End If
		Next
	Next
	If (ST = 0) Then
		BP = BPP
	Else
		BP = BP/ST
	End If
		
	'  ROTATE MAGNETIC VECTOR COMPONENTS FROM SPHERICAL To
	'  GEODETIC COORDINATES
		
	BX = -BT * CA - BR * SA
	BY = BP
	BZ = BT * SA - BR * CA
	'  COMPUTE DECLINATION (DEC), INCLINATION (DIP) And
	'  TOTAL INTENSITY (TI)
		
	BH = Sqrt(BX*BX + BY*BY)
	'	 double TI = Sqrt(BH*BH + BZ*BZ)
	Dim DEC As Double = ATan2(BY,BX)/DTR
	Dim DIP As Double = ATan2(BZ,BH)/DTR
	'  COMPUTE MAGNETIC GRID VARIATION If THE CURRENT
'	//  GEODETIC POSITION Is IN THE ARCTIC Or ANTARCTIC
'	//  (I.E. LAT > +55 DEGREES Or LAT < -55 DEGREES)
'	//
'	//  OTHERWISE, SET MAGNETIC GRID VARIATION To -999.0
		
	Dim GV As Double = -999.0
	If (Abs(LAT) > 55) Then
		If (LAT > 0 And LON > 0) Then GV = DEC - LON
		If (LAT > 0 And LON < 0) Then GV = DEC + Abs(LON)
		If (LAT < 0 And LON > 0) Then GV = DEC + LON
		If (LAT < 0 And LON < 0) Then GV = DEC - Abs(LON)
		If (GV > 180) Then GV = GV - 360
		If (GV < -180) Then GV = GV + 360
	End If
	OTIME = TIME
	OALT = ALT
	OLAT = LAT
	str(0) = DEC
	str(1) = DIP
	str(2) = GV
	Return str
End Sub

Public Sub SetDate (Day As Int, Month As Int, Year As Int)
	TIME = Day / 356 + Month/12 + Year
End Sub


